Subject: bug#44664: 28.0.50; troubles with some chars in term

From: Eli Zaretskii <[email-masked]>
Date: Thu, 19 Nov 2020 18:15:51 +0200

> Date: Thu, 19 Nov 2020 18:11:19 +0300
> From: Jean Louis <[email-masked]>
> Cc: [email-masked], [email-masked], [email-masked]
> 
> >   M-: (font-at POS) RET
> > 
> > where POS is the buffer position of the offending character.
> > Alternatively, go to the character and type "C-u C-x =", it will pop
> > up a buffer with a lot of information including the font.
> 
> The default font probably chosen by Emacs at the same point where
> there was that one char I think it is making problems is this one:
> 
> #<font-object "-GNU #-FreeMono-normal-normal-normal-*-15-*-*-*-m-0-iso10646-1"

And this is different from the font used for, say, ASCII characters?

> Otherwise you may see 2 attached screenshots. First screenshot will
> show condition "before" as that is when I yet did not come to
> allegedly offending characters. There is one line for message of
> Thien-Thi
> 
> What one DOES NOT SEE is that there is actually another invisible
> line, now shown there. I can see it in mutt in xterm, you can find it
> under "Web spy" and before "Thien-Thi". That line is not shown in mutt
> under M-x term, until I come with the mutt highlighted line to it.
> 
> The line is from 2002-03-09 - as I said it cannot be seen.

That mbox file has several email messages where the encoding is either
wrongly declared or is not recognized by mutt.  That's a different
problem, unrelated to term.el and its handling of fonts.

> Then that line shows itself and I can see some replaced characters and
> I can see this character not replaced with that circled ?. It is just
> perception that this character and maybe others are not properly
> interpreted by the terminal or fonts.
> 
>              position: 2833 of 7081 (40%), column: 52
>             character:  (displayed as ) (codepoint 60531, #o166163, #xec73)
>               charset: unicode (Unicode (ISO10646))
> code point in charset: 0xEC73
>                syntax: w 	which means: word
>              category: L:Left-to-right (strong)
>              to input: type "C-x 8 RET ec73"
>           buffer code: #xEE #xB1 #xB3
>             file code: #xEE #xB1 #xB3 (encoded by coding system utf-8-unix)
>               display: no font available
> 
> Character code properties: customize what to show
>   general-category: Co (Other, Private Use)
>   decomposition: (60531) ('')

This is a PUA character, another separate issue (Emacs doesn't expect
to see such characters in human-readable text, and cannot display them
without special tinkering with font setup).

Finally, I don't know what byte sequences did mutt send to the
terminal, it is possible that some problems you see are because
term.el is unable to interpret some sequences that mutt assumes to be
supported.  (What termcap/terminfo entry did you use in that shell,
which tells mutt what commands to send?)

Bottom line, I'm no longer sure which problems we are discussing here,
since we have several unrelated issues involved.  Please consider
separating the issues.